>module Language where
>import Util
>import PrettyP

Naming convention: "D<tag>" means a tag.

>data Document d = DSeq [d]
>		 | DText [Char]
>		 | DTag DocTag d
>		 | DSpace [Char]

>type RDocument = Rec Document

>type DocTag = String

>instance PpShow a => PpShow (Document a) where
>	  pp (DSeq lst) = cat $ map pp lst
>	  pp (DText c) = ptext c
>	  pp (DTag t x) = pp '<' <> pp t <> pp '>' <> pp x <> pp "</" <> pp t <> pp '>'
>	  pp (DSpace x) = pp x

>instance Functor Document where
>	  fmap f (DSeq lst) = DSeq (map f lst)
>	  fmap f (DTag t x) = DTag t (f x)
>	  fmap f (DText x) = DText x
>	  fmap f (DSpace x) = DSpace x

>allowedTags :: [String]
>allowedTags = ["B","EM","I","PL","S","TT","U","0","1","2","3","4","5","6",
>		"7","8","9","r","g","b","c","m","y","k","w"]










