>module Parser (ParserResult(..), didFail, AnnotatedParser,
>		 Parser(..), ExtraParser(..),AEParser, module PrettyP,
>		 newLine, tokens, mappedP, do2,do3,do4,do5,do6,
>		 parseP, annotate,AnnotatedObject,requireP,
>		 annotation, annotateP, annotationP, primitiveAnnotateP,
>		 primitiveAnnotate,
>		 charParser, 
>		 spanParser, spanParserPlus, altParserEither, (=|=), (=*=),
>		 (==|=),(=|==), (==>), (<+++>), (=:=), emptyParser, rep,
>		 repPlus, stringParser, optional, inputOf, getL,setL,
>		 chainPlus,chain,liftLine,
>		 require, MonadicParser, 
>		 setParsedP,emptyParsed,getParsed,ErrorInfo, messageOf,
>		 LineInfo, emptyLineInfo) where
>import Monad
>import Arrow
>import PrettyP
>import Util

>infixl 3 =|=
>infixl 3 ==|=
>infixr 3 =|==
>infixl 2 ==>
>infixl 2 <+++>
>infixl 0 `annotate`
>infixl 0 `primitiveAnnotateP`, `primitiveAnnotate`

>class Ord ei => ErrorInfo ei where
>      messageOf :: PpShow c => ei -> [c] -> Doc -> Doc
>      addTo     :: PpShow c => ei -> c -> ei

>addToEPD :: PpShow chType => LineInfo -> chType -> LineInfo
>addToEPD ed c = ed { lineStr = (lineStr ed) <+> pp c}

>messageOfEI :: PpShow c => LineInfo -> [c] -> Doc -> Doc
>messageOfEI _ _ msg = pp msg -- pp "Line" <+> pp (line ed) <> pp ':' <> msg

>instance ErrorInfo LineInfo where
>         messageOf = messageOfEI
>         addTo = addToEPD        

>instance (Ord a,ErrorInfo b) => ErrorInfo (a,b) where
>         messageOf (_,x) lst d = messageOf x lst d
>         addTo (a,x) c = (a,addTo x c)


>data LineInfo = NewLineInfo { line :: !Int, lineStr :: Doc }

>emptyLineInfo :: LineInfo
>emptyLineInfo = NewLineInfo 1 empty

>instance Ord LineInfo where
>	  x <= y = line x <= line y

>instance Eq LineInfo where
>         (NewLineInfo l1 _) == (NewLineInfo l2 _) = l1 == l2

>type EPD = LineInfo

>data ParserResult c a = ParseOk { value ::  a ,
>				   rest  :: [c],
>				   parsed' :: [c] -> [c]
>				 }
>		       | ParseFail { messages :: Doc, parsed' :: [c] -> [c] }

>getParsed :: ([c] -> [c]) -> [c]
>getParsed f = reverse (f [])

>parsed :: ParserResult c a -> [c]
>parsed pr = getParsed (parsed' pr)

>setParsed :: ParserResult c a -> [c] -> ParserResult c a
>setParsed r v = r { parsed' = (\x -> x ++ v) }


>emptyParsed :: [a] -> [a]
>emptyParsed = id

>instance (Eq a, Eq c)=> Eq (ParserResult c a) where
>	  (ParseOk x r _) == (ParseOk x' r' _) = x == x' && r == r'
>	  (ParseFail _ _) == (ParseFail _ _) = True
>	  _ == _ = False


>instance Functor (ParserResult c) where
>	  fmap f (ParseOk a r p) = ParseOk (f a) r p
>	  fmap _ (ParseFail x p) = ParseFail x p

>instance (PpShow c, PpShow a, PpShow [c]) => PpShow (ParserResult c a) where
>	  pp (ParseOk a [] _) = fsep[text "Successful parse:", nest 4 (pp a)]
>	  pp (ParseOk _ r _) = fsep[text "Unsuccessful parse, extra input:",nest 4 $ enclose (sep (map pp (take 10 r)))]
>	  pp (ParseFail x p') = fsep[text "Unsuccessful",text "parse:",nest 4 x]


>didFail :: ParserResult c a -> Bool
>didFail (ParseFail _ _) = True
>didFail _	       = False


>getL :: MonadicParser p c e => p c e a -> p c e (a,e)
>getL p = do x <- p
>	     e <- getExtraData
>	     return (x,e)
>  `primitiveAnnotateP` pp "getL" <+> annotation p

>setL :: MonadicParser p c e => p c e (a,e) -> p c e a
>setL p = do (x,e) <- p
>	     setExtraData e
>	     return x
>  `primitiveAnnotateP` pp "setL" <+> annotation p

buildEPD :: (PpShow a, Ord a, MonadicParser p c EPD) =>
			     p c (a,EPD) (a,EPD)
buildEPD = arr (\ (x,ed) -> (x,ed { lineStr = lineStr ed <+> pp x }))
   `primitiveAnnotateP` pp "buildEPD"




>class Parser p where
>      (=|=) :: (ErrorInfo e,PpShow c, PpShow [c],PpShow a) => p c e a -> p c e a -> p c e a
>      (==|=) :: (PpShow c,PpShow [c]) => p c e a -> p c e a -> p c e a
>      (=|==) :: (PpShow c,PpShow [c]) => p c e a -> p c e a -> p c e a
>      parseP :: ErrorInfo e => p c e a -> e -> [c]  -> IO (ParserResult c a)
>      mapP   :: (ParserResult c a -> ParserResult c b) -> p c e a -> p c e b
>      succeedP :: (PpShow [c],PpShow c, PpShow a) => ParserResult c a -> p c e a
>      consumeP :: (ErrorInfo e,PpShow c) => p c e c
>      inputOf :: ErrorInfo e => p c e [c]
>      catchP :: p c e a -> (Doc -> p c e a) -> p c e a
>      (==>) :: (ErrorInfo e, PpShow a,
>		PpShow [a],PpShow b,PpShow c, PpShow [c]) =>
>			   p c e [a] -> p a e b -> p c e b
>      a =|== b = b ==|= a

>class Parser p => ExtraParser p where
>      getExtraData :: p c e e
>      setExtraData :: e -> p c e ()

>liftLine :: MonadicParser p c EPD => p c EPD a -> p c EPD (a,EPD)
>liftLine p = arr (\x -> (x,x)) >>> first p

>newLine :: MonadicParser p c EPD => p c EPD (a,EPD) -> p c EPD (a,EPD)
>newLine p = arr (\ed -> ed { line = (line ed) + 1, lineStr = empty }) >>> p

>setParsedP :: (Parser p,Arrow (p c)) => [c] -> p c e a -> p c e a
>setParsedP lst p = mapP (\ res -> setParsed res lst) (arr id) >>> p


>class Parser p => AnnotatedParser p where
>      annotateP :: p c e a -> Doc -> p c e a
>      primitiveAnnotateP :: (PpShow c, ErrorInfo e) =>
>			  p c e a -> Doc -> p c e a
>      primitiveAnnotate :: (MonadicParser p c e, PpShow [c]) =>
>			  p c e a -> Doc -> p c e a
>      annotationP :: p c e a -> Doc

>      primitiveAnnotate z n = primitiveAnnotateP z n
>         `catchP` (\m -> fail $ render (pp "expected" <+> enclose n))

      primitiveAnnotate z n = debugM_ (render n) $ (primitiveAnnotateP z n
         `catchP` (\m -> debug ("fail:",render n) $ fail $ render (pp "expected '"
					<> n <> pp "'")))

>class (ExtraParser p, AnnotatedParser p) => AEParser p

>class (ErrorInfo e, Ord c, Arrow (p c),PpShow c, PpShow [c],AEParser p, MonadPlus (p c e)) => MonadicParser p c e

>instance (AnnotatedParser p) => AnnotatedObject (p c e a) where
>	  annotation = annotationP
>	  annotate = annotateP

>class AnnotatedObject ao where
>      annotation :: ao -> Doc
>      annotate :: ao -> Doc -> ao


>charParser :: (MonadicParser p ch e, Eq ch) => ch -> p ch e ch
>charParser = requireP consumeP

>{-# INLINE spanParser #-}
>spanParser :: MonadicParser p c e => (c -> Bool) -> p c e [c]
>spanParser f = do cc <- consumeP
>		   guard $ f cc
>		   cs <- spanParser f
>		   return (cc:cs)
>	    `mplus` return []

>sumMap :: MonadPlus m => (a -> m b) -> [a] -> m b
>sumMap f = msum . map f

"tokens" will produce a parser from a list of tokens and associated
expressions, which will recognise the tokens by returning the value.

>tokens :: (PpShow [c],Eq c,MonadicParser p c e) => [([c],a)] -> p c e a
>tokens = sumMap doParse
>       where doParse (tok,val) = stringParser tok >> return val
>		      `primitiveAnnotate` (pp tok)


>mappedP :: (PpShow d, PpShow [d], PpShow [c],PpShow c, Eq c, MonadicParser p d e)
>	    => p d e c -> [(c,a)] -> p d e a
>mappedP cons lst = sumMap doParse lst 
>          `primitiveAnnotate` (pp (map fst lst))
>	 where doParse (tok,val) = requireP cons tok >> return val
>				  `primitiveAnnotate` (pp tok)


>spanParserPlus :: MonadicParser p c e => (c -> Bool) -> p c e [c]
>spanParserPlus f = do cc <- consumeP ; guard (f cc)
>		       cs <- spanParser f ; return (cc:cs)

>altParserEither :: MonadicParser p c e => p c e a -> p c e b -> p c e (Either a b)
>altParserEither p q = liftM Left p `mplus` liftM Right q

p <+++> q is a higher order version of ++, i.e. it'll combine two
parsers and uses '++' to combine the data.

>(<+++>) :: (MonadicParser p c e, MonadPlus m)
>	  => p c e (m a) -> p c e (m a) -> p c e (m a)
>p <+++> q = liftM2 mplus p q `primitiveAnnotate`
>		  (annotation p <+> annotation q)

>(=:=) :: MonadicParser p c e => p c e a -> p c e [a] -> p c e [a]
>p =:= q = p >>= \a -> q >>= \b -> return (a:b)


liftM2 (:) p q `primitiveAnnotate`
		  (annotation p <+> annotation q)

>(=*=) :: MonadicParser p c e => p c e a -> p c e b -> p c e (a,b)
>p =*= q = liftM2 (,) p q `primitiveAnnotate`
>	   (annotation p <+> annotation q)

>do2 :: MonadicParser p c e => p c e a -> p c e b -> p c e (a,b)
>do2 = (=*=)

>do3 :: MonadicParser p c e => p c e a -> p c e b -> p c e d -> p c e (a,b,d)
>do3 x y z = liftM3 (,,) x y z `primitiveAnnotate`
>	    (annotation x <+> annotation y <+> annotation z)

>do4 :: MonadicParser p c ee => p c ee a -> p c ee b -> p c ee d 
>			     -> p c ee e -> p c ee (a,b,d,e)
>do4 x y z xx = liftM4 (,,,) x y z xx `primitiveAnnotate`
>	    (annotation x <+> annotation y <+> annotation z
>	     <+> annotation xx)

>do5 :: MonadicParser p c ee => p c ee a -> p c ee b -> p c ee d -> p c ee e 
>			-> p c ee f 
>	-> p c ee (a,b,d,e,f)
>do5 x y z xx yy = liftM5 (,,,,) x y z xx yy `primitiveAnnotate`
>	    (annotation x <+> annotation y <+> annotation z
>	     <+> annotation xx <+> annotation yy)

>do6 :: MonadicParser p c ee => p c ee a -> p c ee b -> p c ee d -> p c ee e -> p c ee f 
>	-> p c ee g -> p c ee (a,b,d,e,f,g)
>do6 x y z xx yy zz = ((return (,,,,,)) `ap` x `ap` y `ap` z
>			      `ap` xx `ap` yy `ap` zz) 
>    `primitiveAnnotate`
>	    (annotation x <+> annotation y <+> annotation z
>	     <+> annotation xx <+> annotation yy <+> annotation zz)

>emptyParser :: MonadicParser p c ee => p c ee ()
>emptyParser = return () `primitiveAnnotate` (pp "emptyParser")

>rep :: (PpShow [a],PpShow [c],MonadicParser p c ee) => p c ee a -> p c ee [a]
>rep p = p =:= rep p ==|= return []
>	 `primitiveAnnotate` (pp '<' <> (annotation p) <> pp ">*")

>chain :: MonadicParser p c ee => p c ee (a,ee) -> p c ee ([a],ee)
>chain p = do (x,n) <- p
>	      (xr,n') <- arr (const n) >>> chain p
>	      return (x:xr,n')
>      ==|= arr (\i -> ([],i))
>chainPlus :: MonadicParser p c ee => p c ee (a,ee) -> p c ee ([a],ee)
>chainPlus p = do (x,n) <- p
>		  (xr,n') <- arr (const n) >>> chain p
>		  return (x:xr,n')

>repPlus :: (PpShow a,PpShow [c],PpShow [a],MonadicParser p c ee) => p c ee a -> p c ee [a] 
>repPlus p = p =:= rep p
>	     `primitiveAnnotate` (pp "<" <> (annotation p) <> pp ">+")

stringParser requires the specified input.

>stringParser :: (PpShow [c],MonadicParser p c e, Eq c) => [c] -> p c e [c]
>stringParser s = mapM charParser s
>	      `primitiveAnnotate` (pp s)

>requireP :: (MonadicParser p c e, Eq a, PpShow a)
>	     => p c e a -> a -> p c e a
>requireP p t = (do x <- p 
>		    if x /= t then
>		       fail (render $ pp "Expected '"
>			    <> pp t <> pp "', got:" <+> pp x) else return x)
>	         `primitiveAnnotate` (pp t)

>require :: (MonadicParser p c EPD, Eq c, PpShow c) =>
>	    c -> p c EPD c
>require = requireP consumeP

optional makes an optional parser.

>optional :: (PpShow a,PpShow [c],MonadicParser p c e) => p c e a -> p c e (Maybe a)
>optional p = liftM Just p =|= return Nothing
>	      `primitiveAnnotate` (pp "{" <> annotation p <> pp "}")








