>module WhiteElim where
>import Util
>import Specification

This optimization removes any whitespace character from the input stream that are
removed by calculation of meaning.

>whiteelim :: Rec CTree -> Rec CTree
>whiteelim tree = fold copynodewithoutspace tree

>copynodewithoutspace :: CTree (Rec CTree) -> Rec CTree
>copynodewithoutspace a@(CT (ContextEntry (SpaceNode _) c)) = In  $CT $ContextEntry
>		(SpaceNode lst) c
>	where decchars = recmeaning (In a)
>             compressed = compresswhitespace Nothing decchars
>	      lst = map ch compressed
>copynodewithoutspace a@(CT _) = In a











